zoukankan      html  css  js  c++  java
  • POJ 1860 Currency Exchange(BellmanFord算法的变形,求正环)

    /*
    POJ 1860
    
    有多种汇币,汇币之间可以交换,这需要手续费,当你用100A币
    交换B币时,A到B的汇率是29.75,手续费是0.39,那么你可以得到
    (100 - 0.39) * 29.75 = 2963.3975 B币。问s币的金额经过交换最终
    得到的s币金额数能否增加
    货币的交换是可以重复多次的,所以我们需要找出是否存在
    正权回路,且最后得到的s金额是增加的
    怎么找正权回路呢?(正权回路:在这一回路上,顶点的权值能不断增加即能一直进行松弛)
    
    关键在于反向利用Bellman-Ford算法
    
    
    单源最短路径算法,因为题目可能存在负边,所以用Bellman Ford算法,
    原始Bellman Ford可以用来求负环,这题需要改进一下用来求正环
    
    一种货币就是图上的一个点
    一个“兑换点”就是图上两种货币之间的一个兑换环,相当于“兑换方式”M的个数,是双边
    唯一值得注意的是权值,当拥有货币A的数量为V时,A到A的权值为K,即没有兑换
    而A到B的权值为(V-Cab)*Rab
    本题是“求最大路径”,之所以被归类为“求最小路径”是因为本题题恰恰
    与bellman-Ford算法的松弛条件相反,求的是能无限松弛的最大正权路径,
    但是依然能够利用bellman-Ford的思想去解题。
    因此初始化d(S)=V   而源点到其他店的距离(权值)初始化为无穷小(0),
    当s到其他某点的距离能不断变大时,说明存在最大路径
    */
    //G++ 696K 0MS
    
    #include<stdio.h>
    #include<string.h>
    #include<algorithm>
    #include<iostream>
    using namespace std;
    
    const int MAXN=110;
    const int MAXE=210;//两倍
    
    double dist[MAXN];
    
    int tol;//边的总数
    int D[MAXE][2];//存边的起点和终点
    double C[MAXE][2];//存汇率和手续费
    
    //修正后的Bellman,求正环
    bool Bellman(int start,int n,double V)
    {
        for(int i=1;i<=n;i++) dist[i]=0;
        dist[start]=V;
        for(int i=1;i<n;i++)//做n-1次
        {
            bool flag=false;//优化
            for(int j=0;j<tol;j++)
            {
                int u=D[j][0];
                int v=D[j][1];
                if(dist[v] < (dist[u]-C[j][1])*C[j][0])//求最大
                {
                    flag=true;
                    dist[v]=(dist[u]-C[j][1])*C[j][0];
                }
            }
            if(!flag)return false;//没有更新,不存在正环
        }
        for(int j=0;j<tol;j++)
          if(dist[D[j][1]]<(dist[D[j][0]]-C[j][1])*C[j][0])
            return true;//有正环
        return false;
    }
    
    
    int main()
    {
        int n;
        int M;
        int a,b;
        double c,d,e,f;
        int S;
        double V;
        while(scanf("%d%d%d%lf",&n,&M,&S,&V)!=EOF)
        {
            tol=0;
            while(M--)
            {
                scanf("%d%d%lf%lf%lf%lf",&a,&b,&c,&d,&e,&f);
                D[tol][0]=a;
                D[tol][1]=b;
                C[tol][0]=c;
                C[tol][1]=d;
                tol++;
                D[tol][0]=b;
                D[tol][1]=a;
                C[tol][0]=e;
                C[tol][1]=f;
                tol++;
            }
            if(Bellman(S,n,V)) printf("YES\n");
            else printf("NO\n");
        }
        return 0;
    }
    Currency Exchange
    Time Limit: 1000MS   Memory Limit: 30000K
    Total Submissions: 13585   Accepted: 4669

    Description

    Several currency exchange points are working in our city. Let us suppose that each point specializes in two particular currencies and performs exchange operations only with these currencies. There can be several points specializing in the same pair of currencies. Each point has its own exchange rates, exchange rate of A to B is the quantity of B you get for 1A. Also each exchange point has some commission, the sum you have to pay for your exchange operation. Commission is always collected in source currency.
    For example, if you want to exchange 100 US Dollars into Russian Rubles at the exchange point, where the exchange rate is 29.75, and the commission is 0.39 you will get (100 - 0.39) * 29.75 = 2963.3975RUR.
    You surely know that there are N different currencies you can deal with in our city. Let us assign unique integer number from 1 to N to each currency. Then each exchange point can be described with 6 numbers: integer A and B - numbers of currencies it exchanges, and real RAB, CAB, RBA and CBA - exchange rates and commissions when exchanging A to B and B to A respectively.
    Nick has some money in currency S and wonders if he can somehow, after some exchange operations, increase his capital. Of course, he wants to have his money in currency S in the end. Help him to answer this difficult question. Nick must always have non-negative sum of money while making his operations.

    Input

    The first line of the input contains four numbers: N - the number of currencies, M - the number of exchange points, S - the number of currency Nick has and V - the quantity of currency units he has. The following M lines contain 6 numbers each - the description of the corresponding exchange point - in specified above order. Numbers are separated by one or more spaces. 1<=S<=N<=100, 1<=M<=100, V is real number, 0<=V<=103.
    For each point exchange rates and commissions are real, given with at most two digits after the decimal point, 10-2<=rate<=102, 0<=commission<=102.
    Let us call some sequence of the exchange operations simple if no exchange point is used more than once in this sequence. You may assume that ratio of the numeric values of the sums at the end and at the beginning of any simple sequence of the exchange operations will be less than 104.

    Output

    If Nick can increase his wealth, output YES, in other case output NO to the output file.

    Sample Input

    3 2 1 20.0
    1 2 1.00 1.00 1.00 1.00
    2 3 1.10 1.00 1.10 1.00
    

    Sample Output

    YES

    Source

    Northeastern Europe 2001, Northern Subregion
     
     
  • 相关阅读:
    题解——洛谷P3812【模板】线性基
    题解——洛谷P2781 传教(线段树)
    题解——洛谷P1962 斐波那契数列(矩阵乘法)
    题解——洛谷P3390 【模板】矩阵快速幂(矩阵乘法)
    题解——牛客网OI赛制测试赛2
    题解——code[vs] 1506 传话(传递闭包)
    题解——Codeforces Round #508 (Div. 2) T3 (贪心)
    题解——Codeforces Round #508 (Div. 2) T2 (构造)
    题解——Codeforces Round #508 (Div. 2) T1 (模拟)
    题解——Codeforces Round #507 (based on Olympiad of Metropolises) T2(模拟)
  • 原文地址:https://www.cnblogs.com/kuangbin/p/2644807.html
Copyright © 2011-2022 走看看